##################### generated by xml-casa (v2) from asdmsummary.xml ###############
##################### f80868a97288f171678257692e450452 ##############################
from __future__ import absolute_import
from casashell.private.stack_manip import find_local as __sf__
from casashell.private.stack_manip import find_frame as _find_frame
from casatools.typecheck import validator as _pc
from casatools.coercetype import coerce as _coerce
from casatasks import asdmsummary as _asdmsummary_t
from collections import OrderedDict
import sys
import os

def static_var(varname, value):
    def decorate(func):
        setattr(func, varname, value)
        return func
    return decorate

class _asdmsummary:
    """
    asdmsummary ---- Summarized description of an ASDM dataset.

    
    Given an ASDM directory, this task will print, to the CASA log,
    information about the content of the dataset contained in that
    directory (down to the level of a subscan).

    --------- parameter descriptions ---------------------------------------------

    asdm    Name of input ASDM directory
            The asdmsummary task prints a description of the
            content of an SDM dataset to the CASA logger.
            
               Example:
               asdm='10C-119_sb3070258_1.55628.42186299768'
    [1;42mRETURNS[1;m    void

    --------- examples -----------------------------------------------------------

    
    For more information, see the task pages of asdmsummary in CASA Docs:
    
    https://casa.nrao.edu/casadocs/
    


    """

    _info_group_ = """information"""
    _info_desc_ = """Summarized description of an ASDM dataset."""

    __schema = {'asdm': {'type': 'cReqPath', 'coerce': _coerce.expand_path}}

    def __init__(self):
        self.__stdout = None
        self.__stderr = None
        self.__root_frame_ = None

    def __globals_(self):
        if self.__root_frame_ is None:
            self.__root_frame_ = _find_frame( )
            assert self.__root_frame_ is not None, "could not find CASAshell global frame"
        return self.__root_frame_

    def __to_string_(self,value):
        if type(value) is str:
            return "'%s'" % value
        else:
            return str(value)

    def __validate_(self,doc,schema):
        return _pc.validate(doc,schema)

    #--------- return nonsubparam values ----------------------------------------------

    def __asdm_dflt( self, glb ):
        return ''

    def __asdm( self, glb ):
        if 'asdm' in glb: return glb['asdm']
        return ''



    #--------- return inp/go default --------------------------------------------------


    #--------- return subparam values -------------------------------------------------


    #--------- subparam inp output ----------------------------------------------------
    def __asdm_inp(self):
        out = self.__stdout or sys.stdout
        description = 'Name of input ASDM directory'
        value = self.__asdm( self.__globals_( ) )
        (pre,post) = ('','') if self.__validate_({'asdm': value},{'asdm': self.__schema['asdm']}) else ('\x1B[91m','\x1B[0m')
        out.write('%-4.4s = %s%-23.22s%s # %-.60s\n' % ('asdm',pre,self.__to_string_(value),post,description))

    #--------- global default implementation-------------------------------------------
    @static_var('state', __sf__('casa_inp_go_state'))
    def set_global_defaults(self):
        self.set_global_defaults.state['last'] = self
        glb = self.__globals_( )
        if 'asdm' in glb: del glb['asdm']


    #--------- inp function -----------------------------------------------------------
    def inp(self):
        self.__asdm_inp( )

    #--------- tget function ----------------------------------------------------------
    def tget(self,file=None):
        from .stack_manip import find_frame
        from runpy import run_path
        filename = None
        if file is None:
            if os.path.isfile("asdmsummary.last"):
                filename = "asdmsummary.last"
        elif isinstance(file, str):
            if os.path.isfile(file):
                filename = file
        if filename is not None:
            glob = find_frame( )
            newglob = run_path( filename, init_globals={ } )
            for i in newglob:
                glob[i] = newglob[i]

    def __call__( self, asdm=None ):
        def noobj(s):
           if s.startswith('<') and s.endswith('>'):
               return "None"
           else:
               return s
        _prefile = os.path.realpath('asdmsummary.pre')
        _postfile = os.path.realpath('asdmsummary.last')
        _return_result_ = None
        _arguments = [asdm]
        _invocation_parameters = OrderedDict( )
        if any(map(lambda x: x is not None,_arguments)):
            # invoke python style
            # set the non sub-parameters that are not None
            local_global = { }
            if asdm is not None: local_global['asdm'] = asdm

            # the invocation parameters for the non-subparameters can now be set - this picks up those defaults
            _invocation_parameters['asdm'] = self.__asdm( local_global )

            # the sub-parameters can then be set. Use the supplied value if not None, else the function, which gets the appropriate default
            

        else:
            # invoke with inp/go semantics
            _invocation_parameters['asdm'] = self.__asdm( self.__globals_( ) )
        try:
            with open(_prefile,'w') as _f:
                for _i in _invocation_parameters:
                    _f.write("%-4s = %s\n" % (_i,noobj(repr(_invocation_parameters[_i]))))
                _f.write("#asdmsummary( ")
                count = 0
                for _i in _invocation_parameters:
                    _f.write("%s=%s" % (_i,noobj(repr(_invocation_parameters[_i]))))
                    count += 1
                    if count < len(_invocation_parameters): _f.write(",")
                _f.write(" )\n")
        except: pass
        try:
            _return_result_ = _asdmsummary_t( _invocation_parameters['asdm'] )
        except: _return_result_ = False
        try:
            os.rename(_prefile,_postfile)
        except: pass
        return _return_result_

asdmsummary = _asdmsummary( )

